#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>
#include<stack>

#define MAX_VERTEX 101
#define VISIT 1
#define UN_VISIT 0
#define CONNECTED 1
using namespace std;
/*
⺻ ı 
v : vertex
e : edge
n : vertex 
m : edge 

Edge_table :    ̺
Vertex_table :  visit  Ȯ ̺
Finish_table : Ž Ϸ   ϴ ̺
Visit_table : visit   vertex 

UN_VISIT :  Ž
VISIT : ڽ Ž 
*/
int Edge_table[MAX_VERTEX][MAX_VERTEX];
int Vertex_table[MAX_VERTEX];

void DFS(int v_i) {
	Vertex_table[v_i] = VISIT;
	cout << v_i << " ";
	for (int i = 0; i < MAX_VERTEX; i++) {
		if (Edge_table[v_i][i] == CONNECTED && Vertex_table[i] == UN_VISIT) {
			DFS(i);
		}
	}
}


int main() {
	int n;
	int m;
	cout << "vertex  : ";
	cin >> n;
	cout << "edge  : ";
	cin >> m;

	cout << "edge  Է" << endl;
	for (int i = 0; i < m; i++) {
		int v_1, v_2;
		cin >> v_1 >> v_2;
		Edge_table[v_1][v_2] = 1;
	}

	memcpy(Vertex_table, Vertex_table + MAX_VERTEX, UN_VISIT);
	for (int i = 1; i <= n; i++) {
		if (Vertex_table[i] == UN_VISIT) {
			DFS(i);
		}
	}
	cout << endl;
	return 0;
}